from urllib.parse import parse_qsl, urlparse
import snowflake.connector
import bodo
from bodo.utils import tracing


def get_connection_params(conn_str):
    import json
    tjiw__eouz = urlparse(conn_str)
    thc__lgkg = {}
    if tjiw__eouz.username:
        thc__lgkg['user'] = tjiw__eouz.username
    if tjiw__eouz.password:
        thc__lgkg['password'] = tjiw__eouz.password
    if tjiw__eouz.hostname:
        thc__lgkg['account'] = tjiw__eouz.hostname
    if tjiw__eouz.port:
        thc__lgkg['port'] = tjiw__eouz.port
    if tjiw__eouz.path:
        hcbbg__qmjl = tjiw__eouz.path
        if hcbbg__qmjl.startswith('/'):
            hcbbg__qmjl = hcbbg__qmjl[1:]
        uhhhq__swb, schema = hcbbg__qmjl.split('/')
        thc__lgkg['database'] = uhhhq__swb
        if schema:
            thc__lgkg['schema'] = schema
    if tjiw__eouz.query:
        for wzc__xqs, pqea__azxp in parse_qsl(tjiw__eouz.query):
            thc__lgkg[wzc__xqs] = pqea__azxp
            if wzc__xqs == 'session_parameters':
                thc__lgkg[wzc__xqs] = json.loads(pqea__azxp)
    thc__lgkg['application'] = 'bodo'
    return thc__lgkg


class SnowflakeDataset(object):

    def __init__(self, batches, schema, conn):
        self.pieces = batches
        self._bodo_total_rows = 0
        for ujwsj__xus in batches:
            ujwsj__xus._bodo_num_rows = ujwsj__xus.rowcount
            self._bodo_total_rows += ujwsj__xus._bodo_num_rows
        self.schema = schema
        self.conn = conn


def get_dataset(query, conn_str):
    qhcgf__lda = tracing.Event('get_snowflake_dataset')
    from mpi4py import MPI
    enrmm__gfmvy = MPI.COMM_WORLD
    kal__moqsu = tracing.Event('snowflake_connect', is_parallel=False)
    wew__ieryn = get_connection_params(conn_str)
    conn = snowflake.connector.connect(**wew__ieryn)
    kal__moqsu.finalize()
    if bodo.get_rank() == 0:
        oamaj__bjhr = conn.cursor()
        qcvn__tkz = tracing.Event('get_schema', is_parallel=False)
        pif__dtkmj = f'select * from ({query}) x LIMIT {100}'
        schema = oamaj__bjhr.execute(pif__dtkmj).fetch_arrow_all().schema
        qcvn__tkz.finalize()
        wwlv__nnx = tracing.Event('execute_query', is_parallel=False)
        oamaj__bjhr.execute(query)
        wwlv__nnx.finalize()
        batches = oamaj__bjhr.get_result_batches()
        enrmm__gfmvy.bcast((batches, schema))
    else:
        batches, schema = enrmm__gfmvy.bcast(None)
    xgo__gxv = SnowflakeDataset(batches, schema, conn)
    qhcgf__lda.finalize()
    return xgo__gxv
