import gc
import inspect
import sys
import types as pytypes
import bodo
master_mode_on = False
MASTER_RANK = 0


class MasterModeDispatcher(object):

    def __init__(self, dispatcher):
        self.dispatcher = dispatcher

    def __call__(self, *args, **kwargs):
        assert bodo.get_rank() == MASTER_RANK
        return master_wrapper(self.dispatcher, *args, **kwargs)

    def __getstate__(self):
        assert bodo.get_rank() == MASTER_RANK
        return self.dispatcher.py_func

    def __setstate__(self, state):
        assert bodo.get_rank() != MASTER_RANK
        zrffu__mlg = state
        zkuuo__xcv = inspect.getsourcelines(zrffu__mlg)[0][0]
        assert zkuuo__xcv.startswith('@bodo.jit') or zkuuo__xcv.startswith(
            '@jit')
        zjrcu__jth = eval(zkuuo__xcv[1:])
        self.dispatcher = zjrcu__jth(zrffu__mlg)


def worker_loop():
    assert bodo.get_rank() != MASTER_RANK
    vtcwj__odw = MPI.COMM_WORLD
    while True:
        jowh__lzo = vtcwj__odw.bcast(None, root=MASTER_RANK)
        if jowh__lzo[0] == 'exec':
            zrffu__mlg = pickle.loads(jowh__lzo[1])
            for kpwdo__cbczt, mojbr__xab in list(zrffu__mlg.__globals__.items()
                ):
                if isinstance(mojbr__xab, MasterModeDispatcher):
                    zrffu__mlg.__globals__[kpwdo__cbczt
                        ] = mojbr__xab.dispatcher
            if zrffu__mlg.__module__ not in sys.modules:
                sys.modules[zrffu__mlg.__module__] = pytypes.ModuleType(
                    zrffu__mlg.__module__)
            zkuuo__xcv = inspect.getsourcelines(zrffu__mlg)[0][0]
            assert zkuuo__xcv.startswith('@bodo.jit') or zkuuo__xcv.startswith(
                '@jit')
            zjrcu__jth = eval(zkuuo__xcv[1:])
            func = zjrcu__jth(zrffu__mlg)
            oai__jrdfb = jowh__lzo[2]
            clhbw__gtyxt = jowh__lzo[3]
            auych__dcjmv = []
            for napbz__qveh in oai__jrdfb:
                if napbz__qveh == 'scatter':
                    auych__dcjmv.append(bodo.scatterv(None))
                elif napbz__qveh == 'bcast':
                    auych__dcjmv.append(vtcwj__odw.bcast(None, root=
                        MASTER_RANK))
            gvb__dsh = {}
            for argname, napbz__qveh in clhbw__gtyxt.items():
                if napbz__qveh == 'scatter':
                    gvb__dsh[argname] = bodo.scatterv(None)
                elif napbz__qveh == 'bcast':
                    gvb__dsh[argname] = vtcwj__odw.bcast(None, root=MASTER_RANK
                        )
            rtd__yuk = func(*auych__dcjmv, **gvb__dsh)
            if rtd__yuk is not None and func.overloads[func.signatures[0]
                ].metadata['is_return_distributed']:
                bodo.gatherv(rtd__yuk)
            del (jowh__lzo, zrffu__mlg, func, zjrcu__jth, oai__jrdfb,
                clhbw__gtyxt, auych__dcjmv, gvb__dsh, rtd__yuk)
            gc.collect()
        elif jowh__lzo[0] == 'exit':
            exit()
    assert False


def master_wrapper(func, *args, **kwargs):
    vtcwj__odw = MPI.COMM_WORLD
    if {'all_args_distributed', 'all_args_distributed_block',
        'all_args_distributed_varlength'} & set(func.targetoptions.keys()):
        oai__jrdfb = ['scatter' for bwf__pbbol in range(len(args))]
        clhbw__gtyxt = {argname: 'scatter' for argname in kwargs.keys()}
    else:
        upgzt__uqo = func.py_func.__code__.co_varnames
        mtlp__yclb = func.targetoptions

        def get_distribution(argname):
            if argname in mtlp__yclb.get('distributed', []
                ) or argname in mtlp__yclb.get('distributed_block', []):
                return 'scatter'
            else:
                return 'bcast'
        oai__jrdfb = [get_distribution(argname) for argname in upgzt__uqo[:
            len(args)]]
        clhbw__gtyxt = {argname: get_distribution(argname) for argname in
            kwargs.keys()}
    hmysq__vdfh = pickle.dumps(func.py_func)
    vtcwj__odw.bcast(['exec', hmysq__vdfh, oai__jrdfb, clhbw__gtyxt])
    auych__dcjmv = []
    for ugl__xwh, napbz__qveh in zip(args, oai__jrdfb):
        if napbz__qveh == 'scatter':
            auych__dcjmv.append(bodo.scatterv(ugl__xwh))
        elif napbz__qveh == 'bcast':
            vtcwj__odw.bcast(ugl__xwh)
            auych__dcjmv.append(ugl__xwh)
    gvb__dsh = {}
    for argname, ugl__xwh in kwargs.items():
        napbz__qveh = clhbw__gtyxt[argname]
        if napbz__qveh == 'scatter':
            gvb__dsh[argname] = bodo.scatterv(ugl__xwh)
        elif napbz__qveh == 'bcast':
            vtcwj__odw.bcast(ugl__xwh)
            gvb__dsh[argname] = ugl__xwh
    hegmh__uhut = []
    for kpwdo__cbczt, mojbr__xab in list(func.py_func.__globals__.items()):
        if isinstance(mojbr__xab, MasterModeDispatcher):
            hegmh__uhut.append((func.py_func.__globals__, kpwdo__cbczt,
                func.py_func.__globals__[kpwdo__cbczt]))
            func.py_func.__globals__[kpwdo__cbczt] = mojbr__xab.dispatcher
    rtd__yuk = func(*auych__dcjmv, **gvb__dsh)
    for kaz__odap, kpwdo__cbczt, mojbr__xab in hegmh__uhut:
        kaz__odap[kpwdo__cbczt] = mojbr__xab
    if rtd__yuk is not None and func.overloads[func.signatures[0]].metadata[
        'is_return_distributed']:
        rtd__yuk = bodo.gatherv(rtd__yuk)
    return rtd__yuk


def init_master_mode():
    if bodo.get_size() == 1:
        return
    global master_mode_on
    assert master_mode_on is False, 'init_master_mode can only be called once on each process'
    master_mode_on = True
    assert sys.version_info[:2] >= (3, 8
        ), 'Python 3.8+ required for master mode'
    from bodo import jit
    globals()['jit'] = jit
    import cloudpickle
    from mpi4py import MPI
    globals()['pickle'] = cloudpickle
    globals()['MPI'] = MPI

    def master_exit():
        MPI.COMM_WORLD.bcast(['exit'])
    if bodo.get_rank() == MASTER_RANK:
        import atexit
        atexit.register(master_exit)
    else:
        worker_loop()
